changequote(`{',`}')dnl
changecom({;})dnl

; General purpose Macro Library, as used in as86 files.
; (c) Franois-Ren "Far" Rideau Dang-Vu Bn 1995

; see info file .../doc/info/m4macros.nfo (section * macro.m4::)

;;;;; Constants
define({__nl__},{
})dnl
;;;;; Argument mangling
define({nargs},{$#})dnl
define({cat},
	{ifelse($#, 0,,
		$#, 1,{$1},
		{format({%s%s},{$1},cat(shift($@)))})})dnl
define({reverse}, {ifelse($#, 0, , $#, 1, {{$1}},
     			  {reverse(shift($@)), {$1}})})dnl
define({forget},)dnl
define({expand},
	$*)dnl
define({quote},
	{{{$*}}})dnl
define({head},
	{$1})dnl
define({tail},
	{shift($@)})dnl
dnl
;;;;; Case independence
define({upcase},  {translit({$*},{a-z},{A-Z})})dnl
define({downcase},{translit({$*},{A-Z},{a-z})})dnl
dnl
;;;;; Loops
define({forloop},
	{pushdef({$1}, {$2})_forloop({$1}, {$2}, {$3}, {$4})popdef({$1})})dnl
define({_forloop},
	{$4{}ifelse($1, {$3}, ,
		{define({$1}, incr($1))_forloop({$1}, {$2}, {$3}, {$4})})})dnl
define({rept},
	{ifelse(eval({$1>0}),1,
		{forloop({i},{1},{$1},{$2})})})dnl
define({irp},
	{cat(pushdef({$1}),
	     pushdef({_loop_body_$1},{shift(shift($@))}),
	     _irp({$1}, $2),
	     popdef({_loop_body_$1}),
	     popdef({$1}))})dnl
define({_irp},
	{ifelse($#, 1,,
		$#, 2,{_irp_once({$1},{$2})},
		{_irp_once({$1},{$2}){}_irp({$1},shift(shift($@)))})})dnl
define({_irp_once},
	{define({$1},{$2})expand(_loop_body_$1){}})dnl
dnl
;;;;; Counters
define({addvar},
	{define({$1},eval($2+$1))})dnl
define({incrvar},
	{define({$1},incr($1))})dnl
define({varadd},
	{cat($1,addvar({$1},{$2}))})dnl
define({varincr},
	{cat($1,incrvar({$1}))})dnl
dnl
;;;;; min, max
define({max},{ifelse(eval(($1)>($2)),1,$1,$2)})dnl
define({min},{ifelse(eval(($1)<($2)),1,$1,$2)})dnl
dnl
;;;;; local labels
define({labelprefix},{L})dnl
define({currentlabel},{0})dnl
define({newlabel},{format({%s%04X},labelprefix,varincr({currentlabel}))})dnl
define({local},
	{cat({pushdef({$1},newlabel)},{expand(shift($@))},{popdef({$1})})})dnl
define({locals},
	{ifelse($#,0,,
		$#,1,{$1},
		{local({$1},locals(shift($@)))})})dnl
dnl
;;;;; metastacks
define({__newstk__},
    {define({__sp__$1},0)})dnl
define({__push__},
    {incrvar({__sp__$1})define({__stk__$1__}__sp__$1,{$2})})dnl
define({__pop__},
    {addvar({__sp__$1},-1)})dnl
define({__pick__},
    {indir({__stk__$1__}eval(__sp__$1-ifelse({$2},,0,{$2})))})dnl
dnl
;;;;; diverting
define({__currentdiversion__},0)dnl
define({indiversion},
{pushdef({__currentdiversion__},{$1})dnl
divert({$1})dnl
expand(shift($@))dnl
popdef({__currentdiversion__})dnl
divert(__currentdiversion__)dnl
})dnl
