;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; vpi386.m4 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;; The i386 implementation of the LLL kernel ;;;;;;;;;;;;;;;;;;;

; See ~moose/info/i386impl.nfo for more info about this.


errprint({Implementation of the i386 LLL kernel.
})dnl


; include(kernel.m4)



;;;;;;;;;;;;;;;;;;;;;;; On-the-fly Code generation ;;;;;;;;;;;;;;;;;;;;;;;;;;;
	NOP_CODE = 0x90
	;87 DB is xchg TOS,TOS
	RETN_CODE = 0xC3
	DSOVRR_CODE = 0x3E
	ESOVRR_CODE = 0x26
	SSOVRR_CODE = 0x36
	CSOVRR_CODE = 0x2E
	FSOVRR_CODE = 0x64
	GSOVRR_CODE = 0x65
	PUSHIMM_CODE = 0x69
